#Ŀ
#(Mystic)    Julian Date Convertor v1.0
#
#    MPL script to convert julian dates
#    to gregorian (MM/DD/YYYY) and back.
#
#            For mystic 1.07.3
# NOTICE
# These functions have been released for the sole purpose of making
# your life easier. If you release a mod that uses these functions
# all I ask is that you give credit to me for my work. Thanks ...
#
# Author: icedevil
# Email: icedevil@icednet.org
# (C) 2003 Icedevil
#
# id-date.mps
# functions jd2greg & greg2jd to convert a julian date to
# gregorian and back again.

function jd2greg (jdtemp longint) : string

var a longint, b longint, c longint
var d longint, e longint, m longint
var day longint, month longint, year longint
var tempint longint, jd longint

begin
  jd := jdtemp
  a := jd + 32044
  b := 4 * a + 3 / 146097
  tempint := b * 146097 / 4
  c := a - tempint
  d := 4 * c + 3 / 1461
  tempint := 1461 * d / 4
  e := c - tempint
  m := 5 * e + 2 / 153
  tempint := 153 * m + 2 / 5
  day := e - tempint + 1 
  tempint := m / 10
  tempint := 12 * tempint
  month := m + 3 - tempint
  tempint := m / 10
  year := b * 100 +  d - 4800 + tempint
  if month < 10 then
    if day < 10 then
      jd2greg := '0' + int2str(month) + '/0' + int2str(day) + '/' + int2str(year)
    else
      jd2greg := '0' + int2str(month) + '/' + int2str(day) + '/' + int2str(year)
    endif
  elseif day < 10 then
    jd2greg := int2str(month) + '/0' + int2str(day) + '/' + int2str(year)
  else
    jd2greg := int2str(month) + '/' + int2str(day) + '/' + int2str(year)
  endif
pend

function greg2jd (gregtemp string) : longint

var a longint, b longint, c longint
var I longint, J longint, K longint
var day longint, month longint, year longint
var tempint longint

begin
  I := str2int(copy(gregtemp,7,4))
  J := str2int(copy(gregtemp,1,2))
  K := str2int(copy(gregtemp,4,2))
  a := J - 14 / 12 + 4800 + I
  tempint := J-14 / 12 * 12
  b := J - 2 - tempint
  c := J - 14 / 12 + 4900 + I / 100
  a := 1461 * a / 4
  b := 367 * b / 12 
  c := 3 * c / 4
  greg2jd := K - 32075 + a + b - c
pend

